## llvm-toolchain-14 14.0.0~+rc1

=== clang/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4)

# If we are not building as a part of LLVM, build Clang as an
# standalone project, using LLVM as an external library:
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  project(Clang)
  set(CLANG_BUILT_STANDALONE TRUE)
endif()

# Must go below project(..)
include(GNUInstallDirs)

if(CLANG_BUILT_STANDALONE)
  set(CMAKE_CXX_STANDARD 14 CACHE STRING "C++ standard to conform to")
  set(CMAKE_CXX_STANDARD_REQUIRED YES)
  set(CMAKE_CXX_EXTENSIONS NO)

  # Rely on llvm-config.
  set(LLVM_CONFIG_OUTPUT)
  if(LLVM_CONFIG)
    set (LLVM_CONFIG_FOUND 1)
    message(STATUS "Found LLVM_CONFIG as ${LLVM_CONFIG}")
    message(DEPRECATION "Using llvm-config to detect the LLVM installation is \
          deprecated.  The installed cmake files should be used \
          instead.  CMake should be able to detect your LLVM install \
          automatically, but you can also use LLVM_DIR to specify \
          the path containing LLVMConfig.cmake.")
    set(CONFIG_COMMAND ${LLVM_CONFIG}
      "--includedir"
      "--prefix"
      "--src-root"
      "--cmakedir"
      "--bindir"
      "--libdir"
      "--assertion-mode"
      )
    execute_process(
      COMMAND ${CONFIG_COMMAND}
      RESULT_VARIABLE HAD_ERROR
      OUTPUT_VARIABLE LLVM_CONFIG_OUTPUT
    )
    if(NOT HAD_ERROR)
      string(REGEX REPLACE
        "[ \t]*[\r\n]+[ \t]*" ";"
        LLVM_CONFIG_OUTPUT ${LLVM_CONFIG_OUTPUT})
    else()
      string(REPLACE ";" " " CONFIG_COMMAND_STR "${CONFIG_COMMAND}")
      message(STATUS "${CONFIG_COMMAND_STR}")
      message(FATAL_ERROR "llvm-config failed with status ${HAD_ERROR}")
    endif()

    list(GET LLVM_CONFIG_OUTPUT 0 MAIN_INCLUDE_DIR)
    list(GET LLVM_CONFIG_OUTPUT 1 LLVM_OBJ_ROOT)
    list(GET LLVM_CONFIG_OUTPUT 2 MAIN_SRC_DIR)
    list(GET LLVM_CONFIG_OUTPUT 3 LLVM_CONFIG_CMAKE_DIR)
    list(GET LLVM_CONFIG_OUTPUT 4 TOOLS_BINARY_DIR)
    list(GET LLVM_CONFIG_OUTPUT 5 LIBRARY_DIR)
    list(GET LLVM_CONFIG_OUTPUT 6 ENABLE_ASSERTIONS)

    # Normalize LLVM_CMAKE_DIR. --cmakedir might contain backslashes.
    # CMake assumes slashes as PATH.
    file(TO_CMAKE_PATH ${LLVM_CONFIG_CMAKE_DIR} LLVM_CMAKE_DIR)
  endif()


  if(NOT MSVC_IDE)
    set(LLVM_ENABLE_ASSERTIONS ${ENABLE_ASSERTIONS}
      CACHE BOOL "Enable assertions")
    # Assertions should follow llvm-config's.
    mark_as_advanced(LLVM_ENABLE_ASSERTIONS)
  endif()

  find_package(LLVM REQUIRED HINTS "${LLVM_CMAKE_DIR}")
  list(APPEND CMAKE_MODULE_PATH "${LLVM_DIR}")

  # We can't check LLVM_CONFIG here, because find_package(LLVM ...) also sets
  # LLVM_CONFIG.
  if (NOT LLVM_CONFIG_FOUND)
    # Pull values from LLVMConfig.cmake.  We can drop this once the llvm-config
    # path is removed.
    set(MAIN_INCLUDE_DIR "${LLVM_INCLUDE_DIR}")
    set(LLVM_OBJ_DIR "${LLVM_BINARY_DIR}")
    # N.B. this is just a default value, the CACHE PATHs below can be overriden.
    set(MAIN_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../llvm")
    set(TOOLS_BINARY_DIR "${LLVM_TOOLS_BINARY_DIR}")
    set(LIBRARY_DIR "${LLVM_LIBRARY_DIR}")
  endif()

  set(LLVM_MAIN_INCLUDE_DIR "${MAIN_INCLUDE_DIR}" CACHE PATH "Path to llvm/include")
  set(LLVM_BINARY_DIR "${LLVM_OBJ_ROOT}" CACHE PATH "Path to LLVM build tree")
  set(LLVM_MAIN_SRC_DIR "${MAIN_SRC_DIR}" CACHE PATH "Path to LLVM source tree")
  set(LLVM_TOOLS_BINARY_DIR "${TOOLS_BINARY_DIR}" CACHE PATH "Path to llvm/bin")
  set(LLVM_LIBRARY_DIR "${LIBRARY_DIR}" CACHE PATH "Path to llvm/lib")

  find_program(LLVM_TABLEGEN_EXE "llvm-tblgen" ${LLVM_TOOLS_BINARY_DIR}
    NO_DEFAULT_PATH)

  # They are used as destination of target generators.
  set(LLVM_RUNTIME_OUTPUT_INTDIR ${CMAKE_BINARY_DIR}/${CMAKE_CFG_INTDIR}/bin)
  set(LLVM_LIBRARY_OUTPUT_INTDIR ${CMAKE_BINARY_DIR}/${CMAKE_CFG_INTDIR}/lib${LLVM_LIBDIR_SUFFIX})
  if(WIN32 OR CYGWIN)
    # DLL platform -- put DLLs into bin.
    set(LLVM_SHLIB_OUTPUT_INTDIR ${LLVM_RUNTIME_OUTPUT_INTDIR})
  else()
    set(LLVM_SHLIB_OUTPUT_INTDIR ${LLVM_LIBRARY_OUTPUT_INTDIR})
  endif()

  option(LLVM_INSTALL_TOOLCHAIN_ONLY
    "Only include toolchain files in the 'install' target." OFF)

  option(LLVM_FORCE_USE_OLD_HOST_TOOLCHAIN
    "Set to ON to force using an old, unsupported host toolchain." OFF)
  option(CLANG_ENABLE_BOOTSTRAP "Generate the clang bootstrap target" OFF)
  option(LLVM_ENABLE_LIBXML2 "Use libxml2 if available." ON)

  include(AddLLVM)
  include(TableGen)
  include(HandleLLVMOptions)
  include(VersionFromVCS)
  include(GetErrcMessages)
  include(LLVMDistributionSupport)

  set(PACKAGE_VERSION "${LLVM_PACKAGE_VERSION}")
  set(BUG_REPORT_URL "${LLVM_PACKAGE_BUGREPORT}" CACHE STRING
    "Default URL where bug reports are to be submitted.")

  if (NOT DEFINED LLVM_INCLUDE_TESTS)
    set(LLVM_INCLUDE_TESTS ON)
  endif()

  include_directories("${LLVM_BINARY_DIR}/include" "${LLVM_MAIN_INCLUDE_DIR}")
  link_directories("${LLVM_LIBRARY_DIR}")

  set( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin )
  set( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib${LLVM_LIBDIR_SUFFIX} )
  set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib${LLVM_LIBDIR_SUFFIX} )

  if(LLVM_INCLUDE_TESTS)
    find_package(Python3 ${LLVM_MINIMUM_PYTHON_VERSION} REQUIRED
      COMPONENTS Interpreter)

    # Check prebuilt llvm/utils.
    if(EXISTS ${LLVM_TOOLS_BINARY_DIR}/FileCheck${CMAKE_EXECUTABLE_SUFFIX}
        AND EXISTS ${LLVM_TOOLS_BINARY_DIR}/count${CMAKE_EXECUTABLE_SUFFIX}
        AND EXISTS ${LLVM_TOOLS_BINARY_DIR}/not${CMAKE_EXECUTABLE_SUFFIX})
      set(LLVM_UTILS_PROVIDED ON)
    endif()

    if(EXISTS ${LLVM_MAIN_SRC_DIR}/utils/lit/lit.py)
      # Note: path not really used, except for checking if lit was found
      set(LLVM_LIT ${LLVM_MAIN_SRC_DIR}/utils/lit/lit.py)
      if(EXISTS ${LLVM_MAIN_SRC_DIR}/utils/llvm-lit)
        add_subdirectory(${LLVM_MAIN_SRC_DIR}/utils/llvm-lit utils/llvm-lit)
      endif()
      if(NOT LLVM_UTILS_PROVIDED)
        add_subdirectory(${LLVM_MAIN_SRC_DIR}/utils/FileCheck utils/FileCheck)
        add_subdirectory(${LLVM_MAIN_SRC_DIR}/utils/count utils/count)
        add_subdirectory(${LLVM_MAIN_SRC_DIR}/utils/not utils/not)
        set(LLVM_UTILS_PROVIDED ON)
        set(CLANG_TEST_DEPS FileCheck count not)
      endif()
      set(UNITTEST_DIR ${LLVM_MAIN_SRC_DIR}/utils/unittest)
      if(EXISTS ${UNITTEST_DIR}/googletest/include/gtest/gtest.h
          AND NOT EXISTS ${LLVM_LIBRARY_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}gtest${CMAKE_STATIC_LIBRARY_SUFFIX}
          AND EXISTS ${UNITTEST_DIR}/CMakeLists.txt)
        add_subdirectory(${UNITTEST_DIR} utils/unittest)
      endif()
    else()
      # Seek installed Lit.
      find_program(LLVM_LIT
                   NAMES llvm-lit lit.py lit
                   PATHS "${LLVM_MAIN_SRC_DIR}/utils/lit"
                   DOC "Path to lit.py")
    endif()

    if(LLVM_LIT)
      # Define the default arguments to use with 'lit', and an option for the user
      # to override.
      set(LIT_ARGS_DEFAULT "-sv")
      if (MSVC OR XCODE)
        set(LIT_ARGS_DEFAULT "${LIT_ARGS_DEFAULT} --no-progress-bar")
      endif()
      set(LLVM_LIT_ARGS "${LIT_ARGS_DEFAULT}" CACHE STRING "Default options for lit")

      get_errc_messages(LLVM_LIT_ERRC_MESSAGES)

      # On Win32 hosts, provide an option to specify the path to the GnuWin32 tools.
      if( WIN32 AND NOT CYGWIN )
        set(LLVM_LIT_TOOLS_DIR "" CACHE PATH "Path to GnuWin32 tools")
      endif()
    else()
      set(LLVM_INCLUDE_TESTS OFF)
    endif()
  endif()

  set(BACKEND_PACKAGE_STRING "LLVM ${LLVM_PACKAGE_VERSION}")
else()
  set(BACKEND_PACKAGE_STRING "${PACKAGE_STRING}")
endif() # standalone

if(NOT DEFINED LLVM_COMMON_CMAKE_UTILS)
  set(LLVM_COMMON_CMAKE_UTILS ${CMAKE_CURRENT_SOURCE_DIR}/../cmake)
endif()

# Make sure that our source directory is on the current cmake module path so that
# we can include cmake files from this directory.
list(INSERT CMAKE_MODULE_PATH 0
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules"
  "${LLVM_COMMON_CMAKE_UTILS}/Modules"
  )

if(LLVM_ENABLE_LIBXML2)
  # Don't look for libxml if we're using MSan, since uninstrumented third party
  # code may call MSan interceptors like strlen, leading to false positives.
  if(NOT LLVM_USE_SANITIZER MATCHES "Memory.*")
    set (LIBXML2_FOUND 0)
    find_package(LibXml2 2.5.3 QUIET)
    if (LIBXML2_FOUND)
      set(CLANG_HAVE_LIBXML 1)
    endif()
  endif()
endif()

include(CheckIncludeFile)
check_include_file(sys/resource.h CLANG_HAVE_RLIMITS)

set(CLANG_RESOURCE_DIR "" CACHE STRING
  "Relative directory from the Clang binary to its resource files.")

set(C_INCLUDE_DIRS "" CACHE STRING
  "Colon separated list of directories clang will search for headers.")

set(GCC_INSTALL_PREFIX "" CACHE PATH "Directory where gcc is installed." )
set(DEFAULT_SYSROOT "" CACHE STRING
  "Default <path> to all compiler invocations for --sysroot=<path>." )

set(ENABLE_LINKER_BUILD_ID OFF CACHE BOOL "pass --build-id to ld")

set(ENABLE_X86_RELAX_RELOCATIONS ON CACHE BOOL
    "enable x86 relax relocations by default")

set(PPC_LINUX_DEFAULT_IEEELONGDOUBLE OFF CACHE BOOL
    "Enable IEEE binary128 as default long double format on PowerPC Linux.")

set(CLANG_SPAWN_CC1 OFF CACHE BOOL
    "Whether clang should use a new process for the CC1 invocation")

option(CLANG_DEFAULT_PIE_ON_LINUX "Default to -fPIE and -pie on Linux" OFF)

# TODO: verify the values against LangStandards.def?
set(CLANG_DEFAULT_STD_C "" CACHE STRING
  "Default standard to use for C/ObjC code (IDENT from LangStandards.def, empty for platform default)")
set(CLANG_DEFAULT_STD_CXX "" CACHE STRING
  "Default standard to use for C++/ObjC++ code (IDENT from LangStandards.def, empty for platform default)")

set(CLANG_DEFAULT_LINKER "" CACHE STRING
  "Default linker to use (linker name or absolute path, empty for platform default)")

set(CLANG_DEFAULT_CXX_STDLIB "" CACHE STRING
  "Default C++ stdlib to use (\"libstdc++\" or \"libc++\", empty for platform default")
if (NOT(CLANG_DEFAULT_CXX_STDLIB STREQUAL "" OR
        CLANG_DEFAULT_CXX_STDLIB STREQUAL "libstdc++" OR
        CLANG_DEFAULT_CXX_STDLIB STREQUAL "libc++"))
  message(WARNING "Resetting default C++ stdlib to use platform default")
  set(CLANG_DEFAULT_CXX_STDLIB "" CACHE STRING
    "Default C++ stdlib to use (\"libstdc++\" or \"libc++\", empty for platform default" FORCE)
endif()

set(CLANG_DEFAULT_RTLIB "" CACHE STRING
  "Default runtime library to use (\"libgcc\" or \"compiler-rt\", empty for platform default)")
if (NOT(CLANG_DEFAULT_RTLIB STREQUAL "" OR
        CLANG_DEFAULT_RTLIB STREQUAL "libgcc" OR
        CLANG_DEFAULT_RTLIB STREQUAL "compiler-rt"))
  message(WARNING "Resetting default rtlib to use platform default")
  set(CLANG_DEFAULT_RTLIB "" CACHE STRING
    "Default runtime library to use (\"libgcc\" or \"compiler-rt\", empty for platform default)" FORCE)
endif()

set(CLANG_DEFAULT_UNWINDLIB "" CACHE STRING
  "Default unwind library to use (\"none\" \"libgcc\" or \"libunwind\", empty to match runtime library.)")
if (CLANG_DEFAULT_UNWINDLIB STREQUAL "")
  if (CLANG_DEFAULT_RTLIB STREQUAL "libgcc")
    set (CLANG_DEFAULT_UNWINDLIB "libgcc" CACHE STRING "" FORCE)
  endif()
endif()

if (NOT(CLANG_DEFAULT_UNWINDLIB STREQUAL "" OR
        CLANG_DEFAULT_UNWINDLIB STREQUAL "none" OR
        CLANG_DEFAULT_UNWINDLIB STREQUAL "libgcc" OR
        CLANG_DEFAULT_UNWINDLIB STREQUAL "libunwind"))
  message(WARNING "Resetting default unwindlib to use platform default")
  set(CLANG_DEFAULT_UNWINDLIB "" CACHE STRING
    "Default unwind library to use (\"none\" \"libgcc\" or \"libunwind\", empty to match runtime library.)" FORCE)
endif()

set(CLANG_DEFAULT_OBJCOPY "objcopy" CACHE STRING
  "Default objcopy executable to use.")

set(CLANG_DEFAULT_OPENMP_RUNTIME "libomp" CACHE STRING
  "Default OpenMP runtime used by -fopenmp.")

# OpenMP offloading requires at least sm_35 because we use shuffle instructions
# to generate efficient code for reductions and the atomicMax instruction on

=== llvm/tools/llvm-debuginfod-find/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  Debuginfod
  Support
  )
add_llvm_tool(llvm-debuginfod-find
  llvm-debuginfod-find.cpp
  )
if(LLVM_INSTALL_BINUTILS_SYMLINKS)
  add_llvm_tool_symlink(debuginfod-find llvm-debuginfod-find)
endif()

=== llvm/tools/llvm-symbolizer/CMakeLists.txt ===
# FIXME: As we plan to execute llvm-symbolizer binary from compiler-rt
# libraries, it has to be compiled for all supported targets (x86_64, i386 etc).
# This means that we need LLVM libraries to be compiled for these
# targets as well. Currently, there is no support for such a build strategy.

set(LLVM_TARGET_DEFINITIONS Opts.td)
tablegen(LLVM Opts.inc -gen-opt-parser-defs)
add_public_tablegen_target(SymbolizerOptsTableGen)

set(LLVM_LINK_COMPONENTS
  DebugInfoDWARF
  DebugInfoPDB
  Debuginfod
  Demangle
  Object
  Option
  Support
  Symbolize
  )

add_llvm_tool(llvm-symbolizer
  llvm-symbolizer.cpp
  DEPENDS
  SymbolizerOptsTableGen
  )

add_llvm_tool_symlink(llvm-addr2line llvm-symbolizer)

if(LLVM_INSTALL_BINUTILS_SYMLINKS)
  add_llvm_tool_symlink(addr2line llvm-symbolizer)
endif()

=== debian/changelog ===
llvm-toolchain-14 (1:14.0.0~+rc1-1) unstable; urgency=medium

  * First testing release of 14
  * Upload to unstable
  Changes for 13:
  * mlir: use the cmake option to avoid installing object files
    MLIR_INSTALL_AGGREGATE_OBJECTS
    Closes upstream #53134
  * Build clangd with GRPC support
    Thanks to Sam McCall for the patch
  * Revert e80c52986e1bb3afa6a92c58b1cb897877923a66 to be able to build on stretch

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 10 Feb 2022 09:25:26 +0100

llvm-toolchain-14 (1:14~++20220202101403+91632c8ac97f-1~exp1) experimental; urgency=medium

  * snapshot = 15, first 14 package
  * Ship clang-linker-wrapper in clang-tools-X.Y

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 02 Feb 2022 22:14:13 +0100

llvm-toolchain-snapshot (1:14~++20220123085548+413684313d9d-1~exp2) experimental; urgency=medium

  * Hide some symbols for omp/arm* and other archs

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 24 Jan 2022 13:56:35 +0100

llvm-toolchain-snapshot (1:14~++20220123085548+413684313d9d-1~exp1) experimental; urgency=medium

  [ Sylvestre Ledru ]
  * Ugly workaround to enable scan-build on runtimes
    debian/patches/use-scan-build-runtimes.diff
  * Python 2 => 3 to unbreak the 'scanbuild_py_makefile.txt' test
  * Enable CLANG_DEFAULT_PIE_ON_LINUX
  * Lower the debhelper dep to 10 for debian stretch
  * Rename ocaml-nox => ocaml-base
  * Update of the ocaml doc path to catch a different path

  [ Samuel Thibault ]
  * Explicitly link against -latomic on hurd-i386 as well.

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 23 Jan 2022 20:48:09 +0100

llvm-toolchain-snapshot (1:14~++20220107114130+3a604fdbcd5f-1~exp1) experimental; urgency=medium

  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 07 Jan 2022 23:58:01 +0100

llvm-toolchain-snapshot (1:14~++20211230084136+a96fe1bf3b32-1~exp1) experimental; urgency=medium

  * New snapshot release
  * Build and ship MLIR as 3 new packages (libmlir-14-dev, libmlir-14
    and mlir-14-tools)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 29 Dec 2021 21:08:20 +0100

llvm-toolchain-snapshot (1:14~++20211221121559+9e3ae8d296aa-1~exp1) experimental; urgency=medium

  * New snapshot release
  * Remove some old mach lld libraries. Remove upstream in 9e3552523ebd3385487e01e3e7af37b8c0efaf57
    liblldReaderWriter.a liblldDriver.a liblldYAML.a liblldCore.a liblldMachOOld.a
  * Also install llvm-debuginfod-find in llvm-14

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 03 Dec 2021 13:19:39 +0100

llvm-toolchain-snapshot (1:14~++20211113111058+6a40854ce507-1~exp1) experimental; urgency=medium

  * experimental New snapshot release
  * Adjust the libomp5 symbols

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 13 Nov 2021 23:15:48 +0100

llvm-toolchain-snapshot (1:14~++20211113102219+b5ff187b7b51-1~exp1) experimental; urgency=medium

  * Remove the triple patch. it is causing the library search path to fail.
    Add a test in debian/qualify-clang.sh to verify we don't regress
  * Fix the "all" build
  * Disable LIBCXX_USE_COMPILER_RT on s390x, armel and x32 as it fails. See bug 52022
  * Adjust the libomp_start_tool visibility on armhf
  * Be more flexible to install libomptarget-*.bc
    (ex: libomptarget-new-nvptx-*.bc are new)
  * Force the i386 triple -DLLVM_HOST_TRIPLE=i386-linux-gnu
    Sometimes, on i386, the library detection is failing (often on z3
    or ffi)
    'Could NOT find Z3:'
  * Add '-DCMAKE_FIND_DEBUG_MODE=true' to help wit debugging
  * Disable the build of libclc on old Ubuntu (Groovy & focal)
    as llvm-spir is too old on these version.
    See bug #52200
  * Adjust the sphinx build as the makefile have been removed
  * If lua is available on the system at built time, a lua lldb binding
    was created. It was leading to some build failures depending
    on the package installed on the build system.
    Force the deactivation of the lua build when lldb is built.
  * libomp: add new symbols
    - GOMP_5.0.1
    - GOMP_alloc
    - GOMP_free
    - __kmpc_aligned_alloc
    - __kmpc_atomic_bool_1_cas
    - __kmpc_atomic_bool_1_cas_cpt
    - __kmpc_atomic_bool_2_cas
    - __kmpc_atomic_bool_2_cas_cpt
    - __kmpc_atomic_bool_4_cas
    - __kmpc_atomic_bool_4_cas_cpt
    - __kmpc_atomic_bool_8_cas
    - __kmpc_atomic_bool_8_cas_cpt
    - __kmpc_atomic_float10_max
    - __kmpc_atomic_float10_max_cpt
    - __kmpc_atomic_float10_min
    - __kmpc_atomic_float10_min_cpt
    - __kmpc_atomic_val_1_cas
    - __kmpc_atomic_val_1_cas_cpt
    - __kmpc_atomic_val_2_cas
    - __kmpc_atomic_val_2_cas_cpt
    - __kmpc_atomic_val_4_cas
    - __kmpc_atomic_val_4_cas_cpt
    - __kmpc_atomic_val_8_cas
    - __kmpc_atomic_val_8_cas_cpt
    - omp_aligned_alloc
    - omp_aligned_calloc
  * Install llvm-tli-checker in llvm-X.Y

  [ Erik Maciejewski ]
  * Merge migration to 2stage runtimes build 13 => 14

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 13 Nov 2021 10:26:41 +0100

llvm-toolchain-snapshot (1:14~++20211111061527+d56b171ee965-1~exp1) experimental; urgency=medium

  * Remove the triple patch. it is causing the library search path to fail.
    Add a test in debian/qualify-clang.sh to verify we don't regress
  * Fix the "all" build
  * Disable LIBCXX_USE_COMPILER_RT on s390x, armel and x32 as it fails. See bug 52022
  * Adjust the libomp_start_tool visibility on armhf
  * Be more flexible to install libomptarget-*.bc
    (ex: libomptarget-new-nvptx-*.bc are new)
  * Force the i386 triple -DLLVM_HOST_TRIPLE=i386-linux-gnu
    Sometimes, on i386, the library detection is failing (often on z3
    or ffi)
    'Could NOT find Z3:'
  * Add '-DCMAKE_FIND_DEBUG_MODE=true' to help wit debugging
  * Disable the build of libclc on old Ubuntu (Groovy & focal)
    as llvm-spir is too old on these version.
    See bug #52200
  * Adjust the sphinx build as the makefile have been removed
  * If lua is available on the system at built time, a lua lldb binding


=== debian/control ===
Source: llvm-toolchain-14
Section: devel
Priority: optional
Rules-Requires-Root: no
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: debhelper (>= 10.0), cmake, ninja-build,
    chrpath, texinfo, sharutils,
    libelf-dev,
    libffi-dev,
    lsb-release, patchutils, diffstat, xz-utils, python3-dev,
    libedit-dev, libncurses5-dev, swig, python3-six, python3-sphinx (>= 1.3.6),
    binutils-dev,
    libxml2-dev,
    libjsoncpp-dev, pkg-config,
    lcov, procps, help2man, zlib1g-dev,
    g++-multilib [amd64 i386 kfreebsd-amd64 mips64 mips64el mipsel powerpc ppc64 s390 s390x sparc sparc64 x32],
    libjs-mathjax, python3-recommonmark,
    doxygen, gfortran,
    ocaml-base [amd64 arm64 armhf ppc64el riscv64 s390x] | ocaml-nox [amd64 arm64 armhf ppc64el riscv64 s390x],
    ocaml-findlib [amd64 arm64 armhf ppc64el riscv64 s390x],
    libctypes-ocaml-dev [amd64 arm64 armhf ppc64el riscv64 s390x],
    dh-exec, dh-ocaml [amd64 arm64 armhf ppc64el riscv64 s390x],
    libpfm4-dev [linux-any], python3-setuptools, libz3-dev,
    llvm-spirv [ amd64 arm64 armel armhf mips64el mipsel ppc64el s390x ] <!stage1> | hello [!i386],
    spirv-tools [ linux-any ] | hello [ !i386],
    libgrpc++-dev, libprotobuf-dev, protobuf-compiler, protobuf-compiler-grpc
# "| hello" is for older buster/bionic distros without spirv support
Build-Conflicts: oprofile
Standards-Version: 4.2.1
Homepage: https://www.llvm.org/
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain.git -b 14
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain/tree/14

# ------------- clang -------------

Package: clang-14
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc}, libclang-common-14-dev (= ${binary:Version}),
 llvm-14-linker-tools (= ${binary:Version}),
 libclang1-14 (= ${binary:Version}), libc6-dev, binutils
Provides: c-compiler, objc-compiler, c++-compiler
Recommends: llvm-14-dev, python3
# libomp-14-dev
Suggests: clang-14-doc
Description: C, C++ and Objective-C compiler
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.

Package: clang-tools-14
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-14 (= ${binary:Version}),
 python3
Description: clang-based tools for C/C++ developments
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains some clang-based tools like scan-build, clang-cl, etc.

Package: clang-format-14
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm14 (= ${binary:Version})
Description: Tool to format C/C++/Obj-C code
 Clang-format is both a library and a stand-alone tool with the goal of
 automatically reformatting C++ sources files according to configurable
 style guides. To do so, clang-format uses Clang's Lexer to transform an
 input file into a token stream and then changes all the whitespace around
 those tokens. The goal is for clang-format to both serve both as a user
 tool (ideally with powerful IDE integrations) and part of other
 refactoring tools, e.g. to do a reformatting of all the lines changed
 during a renaming.
 .
 This package also provides vim and emacs plugins.

Package: clang-tidy-14
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm14 (= ${binary:Version}), libclang-common-14-dev,
 clang-tools-14, python3-yaml
Description: clang-based C++ linter tool
 Provide an extensible framework for diagnosing and fixing typical programming
 errors, like style violations, interface misuse, or bugs that can be deduced
 via static analysis. clang-tidy is modular and provides a convenient interface
 for writing new checks.

Package: clangd-14
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libclang-common-14-dev (= ${binary:Version})
Description: Language server that provides IDE-like features to editors
 clangd understands your C++ code and adds smart features to your editor:
  - code completion
  - compile errors
  - go-to-definition
  - and more.
 .
 clangd is a language server that implements the Language Server Protocol;
 it can work with many editors through a plugin.

Package: clang-14-doc
Architecture: all
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-mathjax
Description: C, C++ and Objective-C compiler - Documentation
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the documentation.

Package: libclang1-14
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang library.
 .
 The C Interface to Clang provides a relatively small API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-14-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc}, libclang1-14 (= ${binary:Version}),
 libclang-common-14-dev (= ${binary:Version})
Description: Clang library - Development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang headers to develop extensions over
 libclang1-14.

Package: libclang-common-14-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm14 (= ${binary:Version})
Description: Clang library - Common development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang generic headers and some libraries
 (profiling, etc).

Package: libclang-cpp14
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm14 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-cpp14-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 libclang-cpp14 (= ${binary:Version})
# Move of libclang-cpp.so into libclang-cpp14.dev
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.
 .
 This package contains symlinks without a version number, which needed by
 linker at build time.


Package: libfuzzer-14-dev
Architecture: linux-any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-14 (= ${binary:Version})
Description: Library for coverage-guided fuzz testing
 LibFuzzer is a library for in-process, coverage-guided, evolutionary fuzzing
 of other libraries.
 .
 LibFuzzer is similar in concept to American Fuzzy Lop (AFL), but it performs
 all of its fuzzing inside a single process. This in-process fuzzing can be
 more restrictive and fragile, but is potentially much faster as there is no
 overhead for process start-up.
 .
 The fuzzer is linked with the library under test, and feeds fuzzed inputs to
 the library via a specific fuzzing entrypoint (aka 'target function'); the
 fuzzer then tracks which areas of the code are reached, and generates mutations
 on the corpus of input data in order to maximize the code coverage. The code
 coverage information for libFuzzer is provided by LLVM's SanitizerCoverage
 instrumentation.


Package: python3-clang-14
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libclang-14-dev
Replaces: python-clang-x.y,
Conflicts: python-clang-x.y
Provides: python-clang-x.y
Description: Clang Python Bindings
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This binding package provides access to the Clang compiler and libraries.

Package: clang-14-examples
Architecture: any
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Clang examples
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang examples.

# ------------- LLVM -------------

Package: libllvm14
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Modular compiler and toolchain technologies, runtime library
 LLVM is a collection of libraries and tools that make it easy to build
 compilers, optimizers, just-in-time code generators, and many other
 compiler-related programs.
 .
 This package contains the LLVM runtime library.

Package: llvm-14-linker-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Modular compiler and toolchain technologies - Plugins
 LLVM is a collection of libraries and tools that make it easy to build

=== debian/rules ===
#!/usr/bin/make -f

# polly & lldb aren't enabled for every platform
PROJECTS = clang;clang-tools-extra;lld;cross-project-tests;mlir
# openmp & libunwind aren't enabled for every platform
RUNTIMES = compiler-rt;libcxx;libcxxabi

TARGET_BUILD	:= build-llvm
TARGET_BUILD_STAGE2    := $(TARGET_BUILD)/tools/clang/stage2-bins
DEB_INST		:= $(CURDIR)/debian/tmp/

GXX_VERSIONED_PACKAGE    := $(shell dpkg-query -W -f '$${Depends}' g++ | grep -o 'g++-[0-9][0-9.]*' | tail -n1 )
GXX_VERSIONED_EXECUTABLE := $(shell dpkg -L $(GXX_VERSIONED_PACKAGE) | grep '/usr/bin/g++-[0-9][0-9.]*' | xargs ls -d | tail -n1 )
GCC_VERSION              := $(subst /usr/bin/g++-,,$(GXX_VERSIONED_EXECUTABLE))

LLVM_VERSION   := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9]+).*,\1,p")
LLVM_VERSION_FULL := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\1,p")
LLVM_VERSION_SNAPSHOT := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:(.*),\1,p")
ifeq ($(LLVM_VERSION),$(LLVM_VERSION_FULL))
	LLVM_VERSION_FULL := $(LLVM_VERSION).0.0
endif

SONAME_EXT      := 1
# clang soname has started with llvm-toolchain-13.
# it is normal that 13 is what is seen in 14 or later version as
# it is bumped only with abi changes
SONAME_CLANG      := 13
SONAME_OPENMP	:= 5
# Manage the case when the version is 3.5~svn213052-1~exp1 or 3.4.2-1
DEBIAN_REVISION := $(shell dpkg-parsechangelog |  sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\3,p")
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
else
  NJOBS := $(shell nproc)
endif

VENDOR=$(shell lsb_release -is)
DISTRO=$(shell lsb_release -sc)

DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')

include /usr/share/dpkg/architecture.mk

CONFIGURE_EXTRA =

# dpkg-buildflags support
# disable fixfilepath in favor of the llvm-project supplied flavor, disable lto
export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
# these are handled on a per stage / build basis
export DEB_CFLAGS_MAINT_STRIP = -g -O2
export DEB_CXXFLAGS_MAINT_STRIP = -g -O2

include /usr/share/dpkg/buildflags.mk

# We use a stage2 build. It means that a first clang is built using gcc,
# a second clang is built with the first
# And the various compoments are built using the second clang.
# See https://llvm.org/docs/AdvancedBuilds.html

# collect additional flags for all stages all builds
CFLAGS_EXTRA = -Wno-unused-command-line-argument
CXXFLAGS_EXTRA = -Wno-unused-command-line-argument
LDFLAGS_EXTRA = -Wl,--build-id

# collect all flags for stage 1 toolchain build only
STAGE_1_CFLAGS = $(CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS)
STAGE_1_CXXFLAGS = $(CXXFLAGS) $(CXXFLAGS_EXTRA) $(CPPFLAGS)
STAGE_1_LDFLAGS = $(LDFLAGS) $(LDFLAGS_EXTRA)

# collect all flags for stage 2 toolchain and stand-alone builds
STAGE_2_CFLAGS = $(CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS)
STAGE_2_CXXFLAGS = $(CXXFLAGS) $(CXXFLAGS_EXTRA) $(CPPFLAGS)
STAGE_2_LDFLAGS = $(LDFLAGS) $(LDFLAGS_EXTRA)

# collect additional cmake options for toolchain build configuration
STAGE_1_CMAKE_EXTRA =
STAGE_2_CMAKE_EXTRA =
STAGE_ALL_CMAKE_EXTRA =
# toolchain config-only var combining all stage 1 cmake options
CMAKE_EXTRA = $(STAGE_1_CMAKE_EXTRA) $(STAGE_ALL_CMAKE_EXTRA)
# toolchain config-only var prepending BOOTSTRAP_ to all stage 2 cmake options
BOOTSTRAP_CMAKE_EXTRA = $(foreach extra,$(STAGE_2_CMAKE_EXTRA) $(STAGE_ALL_CMAKE_EXTRA), $(subst -D,-DBOOTSTRAP_,$(extra)))

BASE_PATH := $(CURDIR)
STAGE_1_BIN_DIR := $(BASE_PATH)/$(TARGET_BUILD)/bin
STAGE_1_LIB_DIR := $(BASE_PATH)/$(TARGET_BUILD)/lib
STAGE_2_BIN_DIR := $(BASE_PATH)/$(TARGET_BUILD_STAGE2)/bin
STAGE_2_LIB_DIR := $(BASE_PATH)/$(TARGET_BUILD_STAGE2)/lib

# toggleable defaults
COMPILER_RT_USE_BUILTINS_LIBRARY := ON
LIBCXX_EXCEPTIONS := ON
LIBCXX_USE_COMPILER_RT := ON

ifneq (,$(filter $(DEB_HOST_ARCH),sparc sparc64))
STAGE_1_CMAKE_EXTRA += -DLLVM_PARALLEL_LINK_JOBS=4
endif

ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386 armel mipsel powerpc powerpcspe riscv64))
# For some reason, in the stage2 build, when clang is used to compile
# itself. The atomic detection is failing on armel and riscv64. Forcing the inclusion
# everywhere and in all stages
LDFLAGS_EXTRA += -latomic
endif

ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' g++-$(GCC_VERSION)) lt 4.9-20140411-1~ ; echo $$?),0)
# Too old version of gcc. Force 4.9
	GCC_VERSION := 4.9
endif

Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=OFF
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libz3-dev) gt 4.7.0; echo $$?),0)
# no ocaml support in main for Ubuntu
ifneq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=ON
endif
endif
STAGE_2_CMAKE_EXTRA += $(Z3_FLAG)

# Change the default CPU for s390x
ZARCH=z196
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
ZARCH=z13
endif
STAGE_2_CMAKE_EXTRA += -DCLANG_SYSTEMZ_DEFAULT_ARCH=$(ZARCH)

# clangd remote index support requires GRPC & protobuf.
# Enable if minimum tested versions are available.
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libgrpc++-dev) gt 1.30.0; echo $$?),0)
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' protobuf-compiler-grpc) gt 1.30.0; echo $$?),0)
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libprotobuf-dev) gt 3.12.0; echo $$?),0)
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' protobuf-compiler) gt 3.12.0; echo $$?),0)
STAGE_2_CMAKE_EXTRA += -DCLANGD_ENABLE_REMOTE=ON
endif
endif
endif
endif

export CC=gcc-$(GCC_VERSION)
export CXX=g++-$(GCC_VERSION)

opt_flags = -O2 -DNDEBUG -g1

ifneq (,$(findstring $(DEB_HOST_ARCH),armel))
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=arm-linux-gnueabi
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_DEFAULT_TARGET_ONLY=ON
# align arch profile with debian baseline
# https://wiki.debian.org/ArmEabiPort
  CFLAGS_EXTRA += -march=armv5t
  CXXFLAGS_EXTRA += -march=armv5t
# disable compiler-rt builtins (not supported for baseline armel arch: armv5t)
# See http://lists.llvm.org/pipermail/llvm-dev/2016-May/099761.html
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_BUILD_BUILTINS=OFF
  COMPILER_RT_USE_BUILTINS_LIBRARY := OFF
  LIBCXX_USE_COMPILER_RT := OFF
# disable scudo standalone (not supported for baseline armel arch: armv5t)
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_BUILD_SCUDO_STANDALONE=OFF
endif

ifneq (,$(findstring $(DEB_HOST_ARCH),armhf))
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=arm-linux-gnueabihf
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_DEFAULT_TARGET_ONLY=ON
# align arch profile with debian baseline
# https://wiki.debian.org/ArmHardFloatPort#Minimum_CPU_.26_FPU
  CFLAGS_EXTRA += -march=armv7-a -mfpu=vfpv3-d16
  CXXFLAGS_EXTRA += -march=armv7-a -mfpu=vfpv3-d16
endif

ifneq (,$(filter $(DEB_HOST_ARCH),i386))
# Sometimes, i386 needs help with the triple
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=i386-linux-gnu
endif

ifneq (,$(filter $(DEB_HOST_ARCH),i386))
# Sometimes, i386 needs help with the triple
  CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=i386-linux-gnu
endif



ifneq (,$(filter $(DEB_HOST_ARCH),mips64el))
# avoid an issue with search path on mips64el
# https://bugs.llvm.org/show_bug.cgi?id=41204
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=mips64el-linux-gnuabi64
endif

ifneq (,$(filter $(DEB_HOST_ARCH),powerpc))
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=powerpc-linux-gnu
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_DEFAULT_TARGET_ONLY=ON
endif

ifneq (,$(filter $(DEB_HOST_ARCH),s390x))
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=s390x-linux-gnu
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_DEFAULT_TARGET_ONLY=ON
  LIBCXX_EXCEPTIONS := OFF
# disable compiler-rt builtins (not supported for s390x)
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_BUILD_BUILTINS=OFF
  COMPILER_RT_USE_BUILTINS_LIBRARY := OFF

## llvm-toolchain-14 14.0.0~+rc2

=== debian/changelog ===
llvm-toolchain-14 (1:14.0.0~+rc2-1~exp1ubuntu1) jammy; urgency=medium

  * Merge with Debian; remaining changes:
    - Don't build clangd with GRPC support on i386.
    - d/rules: Don't remove libRemoteIndex{ServiceProto,Proto}.a nor
      libMonitoringServiceProto.a.  These are necessary for autopkgtest.
      Adjust d/llvm-X.Y-dev.install accordingly when building on
      i386 (i.e., don't install libRemoteIndex{ServiceProto,Proto}.a in
      such case).
    - Ship libRemoteIndex{ServiceProto,Proto}.a in libclang-14-dev.
      llvm-14-dev.
  * Fix installation of python3-lldb files.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Mar 2022 07:06:53 +0100

llvm-toolchain-14 (1:14.0.0~+rc2-1~exp1) unstable; urgency=medium

  * New snapshot release
  * Also path LD_LIBRARY_PATH for install
    when cmake binary backport like on bionic s390x (for apt.llvm.org)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 04 Mar 2022 20:06:44 +0100

llvm-toolchain-14 (1:14.0.0~+rc1-1ubuntu4) jammy; urgency=medium

  * Ship libRemoteIndex{ServiceProto,Proto}.a in libclang-14-dev, not
    llvm-14-dev.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 17 Feb 2022 06:56:46 +0100

llvm-toolchain-14 (1:14.0.0~+rc1-1ubuntu3) jammy; urgency=medium

  * Update library names for LLVM 14.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 15 Feb 2022 06:22:43 +0100

llvm-toolchain-14 (1:14.0.0~+rc1-1ubuntu1) jammy; urgency=medium

  * Don't build clangd with GRPC support on i386.
  * d/rules: Don't remove libRemoteIndex{ServiceProto,Proto}.a nor
    libMonitoringServiceProto.a.  These are necessary for autopkgtest.
    Adjust d/llvm-X.Y-dev.install accordingly when building on
    i386 (i.e., don't install libRemoteIndex{ServiceProto,Proto}.a in such
    case).
  * d/llvm-X.Y-dev.install.in: Install libs mentioned above.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 11 Feb 2022 08:00:59 +0100

llvm-toolchain-13 (1:13.0.1-3) unstable; urgency=medium

  * Fix a typo in an header (closes: #1005195)

  * Also install usr/lib/llvm-@LLVM_VERSION@/lib/libRemoteIndexProto.a
    usr/lib/llvm-@LLVM_VERSION@/lib/libRemoteIndexServiceProto.a
    usr/lib/llvm-@LLVM_VERSION@/lib/libMonitoringServiceProto.a
    in libclang-X.Y-dev
    (Closes: #1005666)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 08 Feb 2022 21:39:18 +0100

llvm-toolchain-12 (1:12.0.1-20) unstable; urgency=medium

  * Also install usr/lib/llvm-@LLVM_VERSION@/lib/libRemoteIndexProto.a
    usr/lib/llvm-@LLVM_VERSION@/lib/libRemoteIndexServiceProto.a
    in libclang-X.Y-dev

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 13 Feb 2022 14:04:40 +0100

llvm-toolchain-12 (1:12.0.1-19) unstable; urgency=medium

  * Build clangd with GRPC support
    Thanks to Sam McCall for the patch

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 29 Jan 2022 10:17:38 +0100

=== debian/rules ===
--- 
+++ 
@@ -126,11 +126,13 @@
 
 # clangd remote index support requires GRPC & protobuf.
 # Enable if minimum tested versions are available.
+ifneq ($(VENDOR)-$(DEB_HOST_ARCH),Ubuntu-i386)
 ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libgrpc++-dev) gt 1.30.0; echo $$?),0)
 ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' protobuf-compiler-grpc) gt 1.30.0; echo $$?),0)
 ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libprotobuf-dev) gt 3.12.0; echo $$?),0)
 ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' protobuf-compiler) gt 3.12.0; echo $$?),0)
 STAGE_2_CMAKE_EXTRA += -DCLANGD_ENABLE_REMOTE=ON
+endif
 endif
 endif
 endif
@@ -194,5 +196,3 @@
   STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_DEFAULT_TARGET_ONLY=ON
   LIBCXX_EXCEPTIONS := OFF
 # disable compiler-rt builtins (not supported for s390x)
-  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_BUILD_BUILTINS=OFF
-  COMPILER_RT_USE_BUILTINS_LIBRARY := OFF
